%cojoc(at)uga.edu
%http://cs.uga.edu/~hanbo/
%2012
%Two View Groupwise Spectural Training
%input:
%Sa: 3 dimensional similarity matrix of all subjects, view a
%Sb: 3 dimensional similarity matrix of all subjects, view b
%VK: #of eigenvectors consider, should be between 2 and #of samples
%iter: #of itertation
%output:
%mva: co-trained matrix of view a of each iteration
%mvb: co-trained matrix of view b of each iteration
%salla, sallb: for test
function [mva mvb salla sallb] = clSpectralDualViewGroupTraining_group(Sa,Sb,VK,iter)
    if(min(Sa(:))<0)
        error('error: similarity should be larger or equal to 0.');
    end
    if(min(Sb(:))<0)
        error('error: similarity should be larger or equal to 0.');
    end
    subNum=size(Sa,3);
    sfa=Sa;
    sfb=Sb;
    salla=cell(iter+1,1);
    sallb=cell(iter+1,1);
    mva=cell(iter+1,1);
    mvb=cell(iter+1,1);
    
    salla{1}=sfa;
    mva{1}=mean(sfa,3);
    sallb{1}=sfb;
    mvb{1}=mean(sfb,3);
    
    
    Vall=cell(subNum,1);
    Vmap=zeros(size(Sa,1));
    for i=1:iter
        %obtain eigenvector of each subject and view
        for subi=1:subNum
            Vall{subi}=clSpectralGetSimMatEigenvector(sfa(:,:,subi),VK);
            Vtmp=clSpectralGetSimMatEigenvector(sfb(:,:,subi),VK);
            Vall{subi}=[Vall{subi} Vtmp];
            Vmap=Vmap+Vall{subi}*Vall{subi}';
        end
        
        %map each subject and each view
        for subi=1:subNum
            tmp=(Vmap-Vall{subi}*Vall{subi}')*sfa(:,:,subi); %map to eigenspace
            tmp=tmp+tmp';               %symmentrilize
            tmp(tmp<0)=0;               %set negative value to 0
            tmp=tmp-diag(diag(tmp));    %remove diagnol value
            tmp=clNormalizeMat(tmp);    %normalize matrix
            sfa(:,:,subi)=tmp;
            tmp=(Vmap-Vall{subi}*Vall{subi}')*sfb(:,:,subi); %map to eigenspace
            tmp=tmp+tmp';               %symmentrilize
            tmp(tmp<0)=0;               %set negative value to 0
            tmp=tmp-diag(diag(tmp));    %remove diagnol value
            tmp=clNormalizeMat(tmp);    %normalize matrix
            sfb(:,:,subi)=tmp;
        end
        salla{i+1}=sfa;
        mva{i+1}=mean(sfa,3);
        sallb{i+1}=sfb;
        mvb{i+1}=mean(sfb,3);
        disp([i]);
    end
end