%cojoc(at)uga.edu
%http://cs.uga.edu/~hanbo/
%2012/11/11

%demo script for multiview spectural clustering
%this demo will show how to used clSpectralMultiViewTraining.m works
clear;clc;

%load testing matrices
load demo.mat;
subNum=size(SimFunc,3);
PairFunc=SimFunc;
PairStruc=SimStruc;
K=25;

%pairwise training
for i=1:subNum
    [PairFunc(:,:,i) PairStruc(:,:,i)]=...
        clSpectralPairTraining_corr(SimFunc(:,:,i),SimStruc(:,:,i),K,10);
end

%groupwise training
[TFunc, TStruc, AllFunc, AllStruc]=clSpectralDualViewGroupTraining_group(PairFunc, PairStruc, K, 40);

%get convergance point of groupwise trainning
NMIFunc=zeros(length(TFunc),1);
NMIStruc=zeros(length(TFunc),1);
for i=1:length(NMIFunc)
    disp(i);
    NMIFunc(i)=connGetNormalizedMutualInfo(AllFunc{i});
    NMIStruc(i)=connGetNormalizedMutualInfo(AllStruc{i});
end
NMI=(NMIFunc+NMIStruc)/2;

%get clusters
nthr=0.5;
NMI_max=max(NMI); I=find(NMI==NMI_max);
Sim=(TFunc{I}+TStruc{I})/2;
C=clSpectralClusteringNcut(Sim,7,nthr);

%display results
figure; title('NMI of each iteration');
NMIall=[NMI, NMIFunc, NMIStruc];
plot(NMIall);
C=C(:,7); [ignore P]=sort(C);
list=unique(C);
n=length(list);
rect=[];
x=0;y=0;
for i=1:n
    w=sum(C==list(i));
    rect=[rect; x, y, w, w];
    x=x+w;
    y=y+w;
end
figure;
for i=1:subNum
    subplot(subNum,6,(i-1)*6+1); imagesc(SimFunc(P,P,i)); colormap hot; title('func org');
    for j=1:size(rect,1)
        rectangle('Position',rect(j,:),'EdgeColor','m','LineWidth',1.1);
    end
    subplot(subNum,6,(i-1)*6+2); imagesc(SimStruc(P,P,i)); colormap hot; title('struc org');
    for j=1:size(rect,1)
        rectangle('Position',rect(j,:),'EdgeColor','m','LineWidth',1.1);
    end
    subplot(subNum,6,(i-1)*6+3); imagesc(PairFunc(P,P,i)); colormap hot; title('func pair');
    for j=1:size(rect,1)
        rectangle('Position',rect(j,:),'EdgeColor','m','LineWidth',1.1);
    end
    subplot(subNum,6,(i-1)*6+4); imagesc(PairStruc(P,P,i)); colormap hot; title('struc pair');
    for j=1:size(rect,1)
        rectangle('Position',rect(j,:),'EdgeColor','m','LineWidth',1.1);
    end
    subplot(subNum,6,(i-1)*6+5); imagesc(TFunc{i}(P,P)); colormap hot; title('func group');
    for j=1:size(rect,1)
        rectangle('Position',rect(j,:),'EdgeColor','m','LineWidth',1.1);
    end
    subplot(subNum,6,(i-1)*6+6); imagesc(TStruc{i}(P,P)); colormap hot; title('struc group');
    for j=1:size(rect,1)
        rectangle('Position',rect(j,:),'EdgeColor','m','LineWidth',1.1);
    end
end